<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: tools/ableton/ableton.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: tools/ableton/ableton.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
*
*
* @requires device
*
* @module ableton
*/

const device = require("../devices/device.js")
const tool = require("../tool.js")

var schema = {
  "cue": {
  },
  "collections": {
    "liveset": {
      "type": "object",
      "title": "Livesets",
      "properties": {
        "settings": {
          "type": "object",
          "description": "set the connection properties for this liveset",
          "required": true,
          "properties": {
            "port": {
              "type": "number",
              "default": 0,
              "required": true,
              "description": "port on which the liveset communicates with the plai framework. 0 to set random port."
            },
            "ip": {
              "type": "string",
              "description": "the ip address of the computer your liveset runs on, so the framework can send messages to it."
            },
            "framework_port": {
              "type": "number",
              "description": "define a different port where the liveset sends data to the framework if its different from port above."
            }
          }
        }
      }
    }
  }
}

class Ableton extends tool.Tool {
  constructor() {
    super(schema)
  }

  /**
  * overwrite tool add function:
  * - add a new Show instance with every added collection
  * - add show property to cue schema
  *
  * overwrite tool remove function
  * - remove the show instance
  * - remove its schema properties from the schema
  *
  */
  setup(config) {
    super.setup(config)
      .then(function (result) {
        this.liveset.add = function (data) {
          schema.cue[data.name] = {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {}
            },
            "default": [{}]
          }
          data["collection"] = "liveset"
          this.liveset.items[data.name] = new Liveset(data, this.db, this.db.liveset.document({ "name": data.name }), this.livesetChanges.bind(this))
        }.bind(this)
        this.liveset.remove = function (name) {
          this.liveset.items[name].close()
          delete this.liveset.items[name]
          delete schema.cue[name]
          this.schemaUpdate(schema)
          log.debug(this.name, "Liveset removed: " + name)
        }.bind(this)
        this.liveset.collectItems()
      }.bind(this))
      .catch(function (error) {
        log.error(this.name, error)
      }.bind(this))

    return schema
  }

  cue(data) {
    for (let d in data) {
      if (this.liveset.items.hasOwnProperty(d)) {
        this.liveset.items[d].send(data[d])
      } else {
        log.error(this.name, "no Liveset called " + d)
      }
    }
  }

  command(input) {
    switch (input[0]) {
      case "livesets":
        for (let liveset in this.liveset.items) {
          log.info(this.name, liveset)
        }
        break
      default:
        super.command(input)
        break
    }
  }

  livesetChanges(changes, liveset) {
    for (let change in changes) {
      if (change == "schema") {
        schema.cue[liveset].items.properties = changes[change]
        this.schemaUpdate(schema)
      }
    }
  }
}

/**
* TCP connection to Ableton Live via "plaiforlive" maxforlive plugin
*
* registers mapping from live set and converts it to cue shema for level design
* including all clips, tracks and scenes
*
* @param {Object} config - device config data. see device.OSCdevice
* @param {Document} device_doc - mongodb document connector
* @param {function} callback - to report schema changes to ableton tool
*/
class Liveset extends device.TCPdevice {
  constructor(config, db, device_doc, callback) {
    super(config, db)
    this.doc = device_doc
    this.mapping = { "clips": {}, "tracks": {}, "scenes": {} }
    this.callback = callback

    this.doc.get()
      .then(function (data) {
        if (data.hasOwnProperty('mapping')) {
          this.mapping = data.mapping
          this.schemaUpdate()
        }
      }.bind(this))
      .catch(function (err) {
        log.error(this.name, err)
      }.bind(this))

    /** liveset cue properties */
    this.schema = {
      "play": {
        "type": "object",
        "properties": {
          "clip": {
            "type": "string"
          },
          "scene": {
            "type": "string"
          }
        }
      },
      "stop": {
        "type": "object",
        "properties": {
          "track": {
            "type": "string"
          },
          "clip": {
            "type": "string"
          }
        }
      },
      "mix": {
        "type": "object",
        "properties": {
          "track": {
            "type": "string",
            "required": true
          },
          "value": {
            "required": true,
            "type": "number",
            "format": "range",
            "minimum": -1,
            "maximum": 1,
            "step": "0.01"
          },
          "device": {
            "required": true,
            "type": "string",
            "enum": [
              "panning",
              "volume",
              "track_activator",
              "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"
            ]
          }
        }
      }
    }

    this.callback({ "schema": this.schema }, this.name)
  }

  /**
  * route changes in liveset
  * check for clips, tracks and scenes and add them to cue properties
  */
  handle(message, socket) {
    try {
      message = JSON.parse(message)
    } catch (err) {
      log.warn(this.name, 'error when parsing string to json.')
      log.warn(this.name, err)
    }
    if (message.hasOwnProperty('liveset')) {
      // CLIPS
      this.schema.play.properties.clip['enum'] = []
      this.schema.stop.properties.clip['enum'] = []
      for (let clip in message.liveset.clips) {
        this.schema.play.properties.clip['enum'].push(clip)
        this.schema.stop.properties.clip['enum'].push(clip)
      }

      // TRACKS
      this.schema.stop.properties.track['enum'] = ["master"]
      this.schema.mix.properties.track['enum'] = []
      for (let track in message.liveset.tracks) {
        this.schema.stop.properties.track['enum'].push(track)
        this.schema.mix.properties.track['enum'].push(track)
      }

      // SCENES
      this.schema.play.properties.scene['enum'] = []
      for (let scene in message.liveset.scenes) {
        this.schema.play.properties.scene['enum'].push(scene)
      }
      this.callback({ "schema": this.schema }, this.name)
    } else {
      super.handle(message, socket)
    }
  }
}

module.exports.Plaitool = Ableton
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tool.html">tool</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-tool-Collection.html">Collection</a></li><li><a href="module-tool-Item.html">Item</a></li><li><a href="module-tool-Tool.html">Tool</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Thu Dec 12 2019 19:18:46 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
